/**
 ** KCAD: Kontrol-Alt-Delete
 ** Copyright (c) 2001, Flaming Sword Productions
 ** Released into the Public Domain
 **
 ** This twisted screensaver will allow you to trick your boss
 ** into thinking you're really running Windoze NT on your 
 ** desktop/server, instead of (insert UNIX OS name here).  This
 ** is for all of you out there with pathetic NAZI bosses.  BOFH
 ** all the way!
 **
 ** Brian C. Ledbetter <brian@shadowcom.net>
 ** http://www.shadowcom.net/Software/kss/kcad/
 **/
#include	<iostream>
#include	<stdlib.h>
#include	<qapplication.h>
#include	<qpainter.h>
#include	<qimage.h>
#include	<qtimer.h>
#include	<qcolor.h>
#include	<qlabel.h>
#include	<kglobal.h>
#include	<kglobalsettings.h>
#include	<klocale.h>
#include	<kconfig.h>
#include	<kapp.h>
#include	"kcad.h"
#include	"kcad.moc"

/**
 ** These are the graphics associated with this screensaver.  I
 ** prefer to compile them in, to simplify the installation/distribution
 ** of this screensaver...  C'est la vie, or something?
 **/
#include	"kcad.xpm"
#include	"kcad_kdelike.xpm"
#include	"kcad_hand.xpm"
#include	"kcad_hand_blank.xpm"
#include	"kcad_keys.xpm"
#include	"kcad_small.xpm"

/**
 ** General fine-tuning parameters.  Keeps me from being
 ** bored...
 **/
#define		ANIMATION_DELAY		5000
#define		ANIMATION_STEP		150
#define		ANIMATION_MOVE		5

static const char *CVSID = "$Id: kcad.cpp,v 1.5 2001/06/29 23:27:47 brian Exp $";

extern "C" {
	const char *kss_applicationName = "kcad.kss";
	const char *kss_description = I18N_NOOP("Kontrol-Alt-Delete");
	const char *kss_version = "1.0";

	KScreenSaver *kss_create( WId id ) {
		KLocale::setMainCatalogue("klock");
		return new KCadSaver( id );
	}
	KScreenSaver *kss_setup( WId id ) {
		if(id);
		return false;
	}

};

/**
 ** KCadSaver::KCadSaver(): Construct our illustrious screensaver.
 **/
		KCadSaver::KCadSaver( WId id )
		:KScreenSaver( id ) {

	oKdeLike = false;
	handStep = 0;
	handDir = 1;

	readSettings();
	initialize();

	srand(Swidth);

	connect( &timer, SIGNAL(timeout()), SLOT(slotMoveWin()));
	QTimer::singleShot( 10, this, SLOT(blank()));
	QTimer::singleShot( 30, this, SLOT(slotDrawWin()));
	QTimer::singleShot( 30+ANIMATION_DELAY, this, SLOT(slotMoveHand()));

	timer.start( 7000 );
}

/**
 ** KCadSaver::~KCadSaver(): NOOO!  Don't destroy me!! :)
 **/
		KCadSaver::~KCadSaver() {

	timer.stop();
	QColor::leaveAllocContext();
	QColor::destroyAllocContext( colorContext );
}

/**
 ** KCadSaver::readSettings(): Load this user's settings.
 **/
void		KCadSaver::readSettings() {
KConfig		*config = KGlobal::config();

	config->setGroup("Settings");
	oKdeLike = (config->readEntry( "NtLike", "0" )=="1"?false:true);
}

/**
 ** KCadSaver::initialize(): Initialize the screensaver.  Build our
 ** KCadWindow.
 **/
void		KCadSaver::initialize() {

	colorContext = QColor::enterAllocContext();

	Swidth = width();
	Sheight = height();
	xpos = ypos = 10;

	hand = QImage( kcad_hand_xpm );
	hand_blank = QImage( kcad_hand_blank_xpm );
	keys = QImage( kcad_keys_xpm );

	/**
	 ** Basically, if the SCREEN WIDTH is less than 600,
	 ** we're going to assume that we're running in "small"
	 ** (ahem, "preview") mode.  Thus, we should behave like
	 ** this screensaver does in NT...  Just for kicks and
	 ** grins, of course.
	 **
	 ** My condolences to those of you who have screen resolutions
	 ** smaller than 600.  (mental note, maybe do this only if 
	 ** Swidth < window.width()?)
	 **/
	if( Swidth < 600 ) {
		window = QImage( kcad_small_xpm );
		handDir = 0;

	/**
	 ** ... Otherwise, this is a full-size window.
	 **/
	} else {

		/**
		 ** Draw the screensaver with a KDE-like widget.
		 **/
		if(oKdeLike) {

			/**
			 ** (these values should be changed if the XPM changes.)
			 **/
			handOfsX = 34; handOfsY = 37; keysOfsX = 67; keysOfsY = 85;
			window = QImage( kcad_kdelike_xpm );

		/**
		 ** Super-secret (or not) Windoze NT emulator.
		 **/
		} else {

			/**
			 ** (these values should be changed if the XPM changes.)
			 **/
			handOfsX = 29; handOfsY = 31; keysOfsX = 62; keysOfsY = 79;
			window = QImage( kcad_xpm );

			QPalette stdpalette = palette();  
			QColor bgc = stdpalette.color( QPalette::Active, QColorGroup::Background );
			QColor tbbg = KGlobalSettings::activeTitleColor();
			for(int i=0; i<window.numColors(); i++) {
				QColor clr = window.color( i );

				/**
				 ** Replace the window background color.
				 **/
				if(clr == QColor( 0xff, 0xc0, 0xc0 )) {
					window.setColor( i, bgc.rgb() );

				/**
				 ** Replace the titlebar background color.
				 **/
				} else if(clr == QColor( 0x00, 0x00, 0x80 )) {
					window.setColor( i, tbbg.rgb() );
				}
			}

			/**
			 ** Do the same thing with hand_blank.
			 **/
			for(int i=0; i<hand_blank.numColors(); i++) {
				QColor clr = hand_blank.color( i );
				if(clr == QColor( 0xc0, 0xc0, 0xc0 )) {
					hand_blank.setColor( i, bgc.rgb() );
				}
			}
		}
	}
}

/**
 ** KCadSaver::slotMoveWin(): Move our KCadWindow.
 **/
void		KCadSaver::slotMoveWin() {

	emit blank();
	QTimer::singleShot( 5, this, SLOT(slotDrawWin()));

	/**
	 ** Don't bother moving the hand in the Mini-Saver.
	 **/
	if( handDir ) {
		QTimer::singleShot( ANIMATION_DELAY, this, SLOT(slotMoveHand()));
	}

	xpos = randX();
	ypos = randY();
}

/**
 ** KCadSaver::slotDrawWin(): Physically draw the window on
 ** the screen using a QPainter.
 **/
void		KCadSaver::slotDrawWin() {

	QPainter p( this );
	p.drawImage( xpos, ypos, window );
}

/**
 ** KCadSaver::slotDrawHand(): Physically draw the hand on
 ** the screen using a QPainter.
 **/
void		KCadSaver::slotDrawHand( int handStep ) {

	QPainter p( this );
	p.drawImage( xpos+handOfsX+handStep, ypos+handOfsY+handStep, hand );
}

/**
 ** KCadSaver::slotUndrawHand(): Cover the previous hand's
 ** image over with our background color. (erase it)
 **/
void		KCadSaver::slotUndrawHand( int handStep ) {

	QPainter p( this );
	p.drawImage( xpos+handOfsX+handStep, ypos+handOfsY+handStep, hand_blank );
	p.drawImage( xpos+keysOfsX, ypos+keysOfsY, keys );
}

/**
 ** KCadSaver::slotMoveHand(): This provides the transfixing
 ** icon animation present in the original Microsoft version
 ** of this screensaver.  Boy, I feel more secure, already!
 **/
void		KCadSaver::slotMoveHand() {

	emit slotUndrawHand( handStep );

	handStep += ( handDir * ANIMATION_MOVE );

	if(handStep >= (ANIMATION_MOVE*2)) {
		handDir = -1*handDir;
	}

	emit slotDrawHand( handStep );

	if( handStep > 0 ) {
		QTimer::singleShot( ANIMATION_STEP, this, SLOT(slotMoveHand()));

	} else {
		handStep = 0;
		handDir = -1 * handDir;
	}
}

/**
 ** KCadSaver::blank(): Clear the screen.  This is used initially
 ** and is used whenever we move the window.  (Perhaps there's a
 ** better way to blank the window... I'll implement it before
 ** too long..)
 **/
void		KCadSaver::blank() {

	setBackgroundColor(black);
	erase();
}

/**
 ** KCadSaver::randX(): Generate a random WIDTH position.
 **/
int		KCadSaver::randX() {
unsigned int	x;

	do {
		x = int(rand());
	} while( (x > Swidth - window.width()) );
	return(x);
}

/**
 ** KCadSaver::randY(): Generate a random HEIGHT position.
 **/
int		KCadSaver::randY() {
unsigned int	y;

	do {
		y = int(rand());
	} while( (y > Sheight - window.height()) );
	return(y);
}
